#!/usr/bin/python
# -*- coding:utf-8 -*-

from string import strip, split
from DbWorker import DbWorker
from LOG import *


class DataBase:
	''' '''
	def __init__(self, host, db_name, user, passwd):
		self.host = host
		self.db_name = db_name
		self.user = user
		self.passwd = passwd
		self.db_worker = DbWorker(self.host, self.db_name, self.user, self.passwd)
	
	def get_attributes(self):
		'''Return a tuple with self attributes:
	(self.db_host, self.db_name, self.user, self.passwd) '''
		tuple = (self.host, self.db_name, self.user, self.passwd)
		return tuple

	def launch_query( self, query):
		'''Launch the str attribute  query '''
		data = self.db_worker.launch_query(query)
		return data

	def launch_insert( self, query):
		''' '''
		last_index = self.db_worker.launch_query(query=query, insert=True)
		return last_index

	
	def get_db_worker(self):
		''' Return de db_worker attribute object'''
		return self.db_worker



class OcsDataBase( DataBase):
	''' '''
	def __init__(self,host, db_name, user, passwd ):
		DataBase.__init__(self, host, db_name, user, passwd)
	
	def search_requirements(self, req):
		''' Metodo propio de OcsDatabase. Devuelve una lista con los expedientes que cumplen los req '''
		if not isinstance(req, Requirements):
			LOG( log.err, "Tipo de objeto incorrecto en OcsDatabase.search_requirements")
			return 1
		dict_mysql = req.get_mysql_dict()
		mysql_query = self.make_mysql_query(dict_mysql)
		LOG(log.deb,"La consulta para obtener tags en OcsDataBase.search_requirements es: %s" %mysql_query)
		data = self.db_worker.launch_query(mysql_query)
		return data

	def make_mysql_query(self, dict_mysql_req):
		''' Devuelve una cadena con la consulta tal que así:
		SELECT accountinfo.tag
		FROM accountinfo
		JOIN tabla1 ON accountinfo.hardware_id = tabla1_accountinfo
		JOIN tabla2 ON accountinfo.hardware_id = tabla1_accountinfo
		WHERE tabla1.campo1 = "Hardware1"
		AND tabla2.campo2 = "Hardware2"'''
		mysql_select = "SELECT DISTINCT accountinfo.tag "
		mysql_from = "FROM accountinfo "
		mysql_where = 'WHERE '
		keys_list = dict_mysql_req.keys()
		keys_len = len(keys_list)
		for key_element in keys_list:
			list_element = dict_mysql_req.get(key_element)
			tabla  = key_element 
			req_len = len(list_element)
			if tabla == "hardware":
				# si la tabla es hardware hacemos join por id
				mysql_from = mysql_from + ' JOIN ' +tabla+' ON accountinfo.hardware_id ='+tabla+'.id '
			else:
				# si la tabla es diferente de hardware hacemos join por campo hardware_id
				mysql_from = mysql_from +' JOIN  '+tabla+' ON accountinfo.hardware_id = '+tabla+'.hardware_id '
			for req_element in list_element:
				tabla_campo = req_element[0]
				valor = req_element[1]
				mysql_where = mysql_where +tabla_campo+' LIKE "%'+valor+'%" '
				#if keys_len >= keys_list.index(key_element)+1 and req_len > list_element.index(req_element)+1 :
				mysql_where = mysql_where+' AND '
				LOG(log.deb, "Se inserta al final AND: %s" %mysql_where)
		return '\t'+mysql_select+'\n\t'+mysql_from+'\n\t'+mysql_where[:-4]
	
