#!/usr/bin/python
#-*- coding:utf-8 -*-

from ConfigParser import ConfigParser
import logging
import logging.config
#from Struct import Struct

class Struct:
    def __init__(self, **entries):
        self.__dict__.update(entries)
 
    def __repr__(self):
        args = ['%s=%s' % (k, repr(v)) for (k,v) in vars(self).items()]
        return 'Struct(%s)' % ', '.join(args)


__all__ = [ 'log', 'LOG']

log = Struct(deb='debug', inf='info', war='warning', err='error', crit='critical')


class SingletonLogger(type):
	def __call__(cls, *args):
                
		## Obtenemos el atributo __instance__ de la clase ##
		## si en nulo nstanciamos la clase...Suficiente para un singleton ##
		if getattr(cls, '__instance__', None) is None:
      ## Creamos su espacio en memorio cordialmente ##
			instance = cls.__new__(cls)
      ## inicializamos la clase ##
			instance.__init__()
			## Guardamos su referencia para no instanciarla mas ¡¡Que grande!!##
			cls.__instance__ = instance
		## LLegado aqui la clase esta instanciada seguro ;) ##
		cls.__instance__.logan(*args)
        
class LOG:
	__metaclass__ = SingletonLogger

	# El logger de nuestra clase el encargado de logar
	__logger__    = None

	def __init__ ( self):

		# cargamos la configuración desde el archivo
		cfg = ConfigParser()
		# le pasamos una lista con archivo(s) a leer
		#cfg.read(["/etc/CGAInventorySystem/config_file"])
		#config_file = cfg.get("logConfigFile", "config_file")
		config_file = "/etc/CGAInventorySystem/log.cfg"
		print "INFO: Carga la configuración desde "+config_file
		logging.config.fileConfig(config_file)
		#print "Se crea __loger__"
		self.__logger__ = logging.getLogger("debuger")

	def logan( self, *args):
		if len(args) == 2:
			msg = args[1]
			level = str(args[0])
#			print "Atributo level=%s Type=%s" %(level, str(type(level)))
			try:
				getattr(self.__logger__, level) (msg) 
			except AttributeError, e:
				self.__logger__.error("Se intento logar con un nivel de error desconocido-> %s" %level)
		else:
			self.__logger__.error("Se esta intentando logar con parametros incorectos: %s" %str(args))
			
			
			

