#!/usr/bin/python
# -*- coding: utf-8 -*-

#from sys import exit, path
#path.append("/home/soto/proyectoInventariado/CGAInventorySystem")

from CGAInventorySystem.Exceptions import IncorrectTypeException
from CGAInventorySystem.LOG import *

class Query:
	''' Class to define querys in the OCSInventory database'''
	def __init__( self, table = ''):
		''' Class Query constructor (throw IncorrectTypeException) '''
		#checking type of << table >> (str)
		if not isinstance (table,str): 		
			raise IncorrectTypeException("Query", "table","incorrect attribute type")		
		else:
			# string with the name of the table
			self.table = table
			# the dictionary is indexed by the field value
			# the values field is a list with the values 
			# {field,(value1,value2,value3...)}
			self.values_dict = {}
			
	def __str__(self):
		''' '''
		buffer = " Tabla: %s" %( self.table)
		campo_valor_list = self.values_dict.keys()
		for key_element in campo_valor_list:
			buffer = "%s campo: %s valor:%s"	%(buffer, key_element, self.values_dict.get(key_element))
		return buffer			

	def add_field_value(self,new_field,new_value):
		if not new_value:
			new_value = str()
		elif not isinstance(new_field,str):
			string = "incorrect attribute type at add_field_value. \n Type of field: %s  Type of value: %s" %( type(new_field), type(new_value))
		elif not isinstance(new_value,str):
			string = "incorrect attribute type at add_field_value. \n Type of field: %s  Type of value: %s" %( type(new_field), type(new_value))
			raise IncorrectTypeException ("Query", "table", string)
		if self.values_dict.has_key(new_field):
			# if it's new, we append the new_value to the list
			self.values_dict[new_field].append(new_value)
		else:
			# if the list don't already exists, I create it
			l = [new_value]
			self.values_dict[new_field]=l

	def get_table(self):
		''' Return the string atribute table '''
		return self.table
			
	def get_value(self, field):
		''' Return the list of values'''
		if not isinstance(field, str):
			raise IncorrectTypeException("Query","field","incorrect attribute in get_value: %s" %(str(field)))
		return self.values_dict[field]

	def remove_emptys(self):
		''' '''
		#iteramos sobre las claves que son los nombres de las tablas
		for field_element in self.values_dict.keys():
			#itermos sobre la lista asociada al nombre de la tabla
			for value_list in self.values_dict.get(field_element):
				for value_element in value_list:
					if value_element == '':
						LOG( log.deb, "Elemento de la query vacío" %value_element)
						value_list.remove(value_element)

