#!/usr/bin/python
# -*- coding: utf-8 -*-

#from sys import exit, path
#path.append("~/Dropbox/Programación/ProyectoInventariado/CGAInventorySystem")

from CGAInventorySystem.Exceptions import IncorrectTypeException
from CGAInventorySystem.RulesClass.Query import Query


class Rules:
	''' Class relate several rules with the corresponding tag'''
	
	def __init__ (self, querys=None, comment=''):
		'''Class Rules constructor'''
		#checking querys' type (list)	
		if not querys:
			self.querys=[]
		if querys and not isinstance( querys, list ):
			raise IncorrectTypeException("Rules", "querys","querys attribute isn't a list")
		elif querys and not self.check_querys_type(querys):
			raise IncorrectTypeException("Rules", "querys","Invalid object type in list atribute")
		else:
			self.querys = querys
		#checking type of comment (str)
		if not isinstance(comment, str):	
			raise IncorrectTypeException("Rules", "comment","Invalid type")
		else:
			self.comment = comment

	def __str__(self):
		''' '''
		buffer =  "\nComentario: %s  \nLista de querys:\n"	%(self.comment) 
		 
		if len(self.querys) == 0:
			buffer = buffer+"[]"		
		else:
			for element in self.querys:
				buffer = buffer+"\t "+str(self.querys.index(element)+1)+" : "+str(element)+"\n"
		return buffer
	

	def check_querys_type (self,querys):
		''' '''
		if len(querys) ==0:
			return True
		for element in querys:
			if not isinstance(element,Query):
				return False			
		return True

		
	def add_query(self,new_query):
		''' '''
		if not isinstance(new_query, Query):
			raise IncorrectTypeException("Rules","query","wrong object type")
		else:
			if not self.querys:
				self.querys = list()			
			if new_query != "":
				self.querys.append(new_query)
			else:
				raise IncorrectTypeException("Rules","query","blank atribute")
	
	def remove_empty_querys(self):
		''' For each Query element in self.querys
		Remove if exists any empty value'''
		for query_element in self.querys:
			query_element.remove_emptys()


