#!/usr/bin/python
# -*- coding: utf-8 -*-

######################################
#
#			db_worker.py
#
######################################

from CGAInventorySystem.RulesClass.Rules_dictionary import Rules_dictionary
from CGAInventorySystem.RulesClass.Rules import Rules
from CGAInventorySystem.RulesClass.Key_tag import Key_tag
from CGAInventorySystem.RulesClass.Query import Query
from CGAInventorySystem.LOG import *
from CGAInventorySystem.DataBase import DataBase

from MySQLdb import connect
from MySQLdb.cursors import DictCursor


class Tagger:
	''' '''
	def __init__( self, dataBase, rules_dictionary, force_all=False):
		''' '''
		if not DataBase or not isinstance(dataBase, DataBase):
			raise IncorrectTypeException( 'Tagger', 'dataBase',  '__init__')
		if not rules_dictionary or not isinstance(rules_dictionary, Rules_dictionary):
			raise IncorrectTypeException( 'Tagger', 'dataBase',  '__init__')

		( self.host_name, self.db_name, self.db_user, self.db_passwd) = dataBase.get_attributes()
		self.rules_dictionary = rules_dictionary
		self.force_all = force_all
			
		
	def __str__(self):
		''' '''
		string ="host_name: %s db_user: %s db_passwd: %s db_name: %s force_all: %s\n rules_dictinary: %s"\
		%(self.host_name, self.db_user, self.db_passwd, self.db_name, str(self.force_all), str(self.rules_dictionary))
		return string

	def create_SQL_query(self):
		''' '''
		tag_querys_dict = {}
		#iteramos sobre las keys del dictionario del objeto Rules_dictionary
		for key_tag_element in self.rules_dictionary.dictionary.keys():
			#primero montamos los JOINS
			joins = "hardware "
			where = "WHERE 1 "
			# para generar los joins no necesito meter hardware
			controllers_where = " "
			controllers_join = " "
			for query_element in self.rules_dictionary.dictionary[key_tag_element].querys:
				if query_element.table == "controllers":
					controllers_where, controllers_join = self.make_controllers_fields(query_element)
				else:
					if query_element.table != "hardware":
						joins =  "%s\nLEFT OUTER JOIN %s ON hardware.ID = %s.HARDWARE_ID\n"\
						%(joins,str(query_element.table),str(query_element.table))
					for element_field in query_element.values_dict.keys():
						for list_element in query_element.values_dict[element_field]:
						#if field is NULL or empty
							if  list_element == "None" or list_element == "NULL" :
								where = '%s\nAND %s.%s is null'\
								%(where,query_element.table,element_field)
							else:
								where = '%s\nAND %s.%s="%s"'\
								%(where,query_element.table,element_field,list_element)
			my_query="SELECT hardware.ID\nFROM %s%s %s %s GROUP BY hardware.id"		%(joins,controllers_join,where,controllers_where)
			#LOG( log.deb, "Clave: %s  Consulta: %s" %( key_tag_element.tag, my_query))
			tag_querys_dict[key_tag_element.tag] = my_query
		return tag_querys_dict


	def  make_controllers_fields(self,query):
		''' Function to create the join and where fields to form the mysql query'''
		table = query.table
		list_field_keys = query.values_dict.keys()
		for field in list_field_keys:
			values_list = query.values_dict[field]
			join = "LEFT OUTER JOIN\n (SELECT COUNT(DISTINCT %s) AS n_man,HARDWARE_ID\n  FROM %s\n   WHERE 1 AND(\n   " %(field,table)
			# variable para no poner OR la primera vez que entramos en el bucle
			first = True
			for value in query.get_value(field):		
				if first:
					join = '%s %s.%s="%s"\n   '%(join,table,field,value)
					first = False
				else:
					join = '%s OR %s.%s="%s"\n   '%(join,table,field,value)
			join = "%s )\n GROUP BY HARDWARE_ID\n )AS TMP_CONTROLLERS\nON hardware.ID=TMP_CONTROLLERS.HARDWARE_ID\n" %(join)
			where = '\n AND TMP_CONTROLLERS.n_man = "%s"\n' %(len(values_list))
		return 	where,join


	def launch_querys(self, dictionary):
		''' '''
		#Open database connection
		db_connect = connect(host=self.host_name,
																user=self.db_user,
																passwd=self.db_passwd,
																db=self.db_name)
		LOG( log.deb, "Abriendo conexión con mysql %s %s %s %s para sacar ids"	%(self.db_user, self.db_passwd, self.host_name, self.db_name))
		dict = {}
		for key_element in dictionary.keys():
			sql_query = dictionary[key_element]
			cursor = db_connect.cursor(DictCursor)
			cursor.execute(sql_query)
			data = cursor.fetchall()
			list = []
			for row in data:
				list.append(row["ID"])
			dict[key_element]=list
		# disconnect from server
		db_connect.close()
		return dict

	def update_tags(self, dictionary):
		''' '''
		
		if len(dictionary) == 0:
			LOG( log.deb, "No hay coincidencias según las reglas definidas en rules.xml")
		else:
			db_connect = connect(host=self.host_name,
																user=self.db_user,
																passwd=self.db_passwd, 
																db=self.db_name)
			keys = dictionary.keys()
			for element_tag in keys:
				for element_hw_id in dictionary[element_tag]:
					# iteramos sobre todos los elementos del diccionario
					# esta consulta devuelve TAG,ID_HARDWARE del elemento correspndiente
					# en esta iteracion
					sql_query = "SELECT accountinfo.HARDWARE_ID,accountinfo.TAG\nFROM hardware LEFT OUTER JOIN accountinfo ON hardware.id = accountinfo.HARDWARE_ID\nWHERE hardware.ID = %s" %(str(element_hw_id))

					LOG( log.deb, "\nEtiquetas que se actualizarán con los hardware_id :\n%s" %(sql_query) )

					cursor = db_connect.cursor(DictCursor)
					cursor.execute(sql_query)
					data = cursor.fetchall()
					for row in data:
						update_sql_query=\
							'UPDATE accountinfo SET TAG="%s" WHERE accountinfo.HARDWARE_ID="%s"\n'\
							%(element_tag, str(element_hw_id))
						# si force_all == True asignamos la etiqueta forzosamente
						if self.force_all:
							# actualizamos el campo TAG de la tabla accountinfo
							cursor.execute(update_sql_query)
							#if data:
							#	for element in data:
									#LOG( log.deb, "Resultado: %s \n" %(element))
							#else:
								#LOG( log.deb, "Resultado: %s " %(data))
							#	LOG( log.deb, "El equipo con tag %s se ha actualizado a %s" %( row["TAG"], element_tag))
							#	LOG( log.deb, "Consulta de actualización:\n%s" %(update_sql_query))
						else:
						# si force_all == False vemos si ya tiene TAG asignado
							if row["TAG"] == "NA":
								LOG( log.deb, "El equipo con ID_HARDWARE=%s no tiene etiqueta. Se le asigna: %s"%(element_hw_id, element_tag))
								cursor.execute(update_sql_query)
							elif row["TAG"] != "NA":
								LOG( log.deb, "El equipo con ID_HARDWARE = %s tiene ya asignada la etiqueta: %s" %(element_hw_id, element_tag))
			#es necesario cuando se hacen modificaciones sobre la base de datos
			db_connect.commit() 
			db_connect.close()


	def tag (self):
		''' '''
		dict_tag_query = self.create_SQL_query()
		dict_tag_ids = self.launch_querys(dict_tag_query)

		cant = len(dict_tag_ids)
		LOG( log.deb, "Segun el archivo de reglas, hay %s coincidencias en la base de datos" %(cant))
		LOG( log.deb,  "Imprimiendo dict_tag_ids")
		for key in dict_tag_ids:
			for element in dict_tag_ids[key]:
				LOG( log.deb, "{ Etiqueta %s : hardware.id %s }" %(key,element))
		self.update_tags(dict_tag_ids)
		
